import 'package:crab_ui/augment.dart';
import 'package:crab_ui/collapsableEmailsAndroid.dart';
import 'package:flutter/material.dart';
// import 'dart:ui_web' as ui;
// import 'augment.dart';
// // import 'dart:js_interop' as js; //eventually for manipulating css
// import 'package:pointer_interceptor/pointer_interceptor.dart';
// import 'collapsableEmails.dart';
// import 'api_service.dart';

class EmailView extends StatefulWidget {
  final List<String> emailContent;
  final String from;
  final String name;
  final String to;
  final String subject;
  final String date;
  final String id;
  final List<String> messages;

  const EmailView({
    Key? key,
    required this.emailContent,
    required this.from,
    required this.name, // tf is name
    required this.to,
    required this.subject,
    required this.date,
    required this.id,
    required this.messages,
  }) : super(key: key);
  @override
  _EmailViewState createState() => _EmailViewState();
}

class _EmailViewState extends State<EmailView> {

  @override
  void initState() {
    super.initState();
  }

  void _scrollToNumber(String spanId) {
    // AugmentClasses.handleJump(spanId);
  }
  void _viewSpecs(String command){

  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.name),
      ),
      body: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          children: [
            EmailToolbar(
              onButtonPressed: () => {}, 
              onJumpToNumbering: _scrollToNumber,
              onViewspecs: _viewSpecs,

            ),
            Row(
              children: [
                Expanded(
                  child: Text(
                    widget.subject,
                    style: TextStyle(fontSize: 15),
                    overflow: TextOverflow.visible,
                    softWrap: true,
                  ),
                ),
              ],
            ),
            Row(
              children: [
                Text(
                  'from ${widget.name}',
                  style: TextStyle(fontSize: 8),
                ),
                Text(
                  '<${widget.from}>',
                  style: TextStyle(fontSize: 8),
                ),
                Spacer(),
                Text(
                  widget.date,
                  textAlign: TextAlign.right,
                )
              ],
            ),
            Row(
              children: [
                Text(
                  'to ${widget.to.toString()}',
                  style: TextStyle(fontSize: 8),
                )
              ],
            ),
            Expanded(
              child: CollapsableEmails(
                thread: widget.messages, 
                threadMarkdown: widget.emailContent, 
                threadIDs: widget.id,
              ),
            ),
          ],
        ),
      ) 
    );
  }
}